package com.gemho.environment.service.impl;


import com.gemho.environment.model.Devicetype;
import com.gemho.environment.model.DevicetypeDto;
import com.gemho.environment.repository.DevicetypeRepository;
import com.gemho.environment.service.DevicetypeService;
import com.gemho.environment.service.mapper.DevicetypeMapper;
import com.gemho.environment.utils.ValidationUtil;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
* @author 靖小侠
* @date 2020-05-08
*/
@Service
//@CacheConfig(cacheNames = "devicetype")
@Transactional(propagation = Propagation.SUPPORTS, readOnly = true, rollbackFor = Exception.class)
public class DevicetypeServiceImpl implements DevicetypeService {

    private final DevicetypeRepository devicetypeRepository;

    private final DevicetypeMapper devicetypeMapper;

    public DevicetypeServiceImpl(DevicetypeRepository devicetypeRepository, DevicetypeMapper devicetypeMapper) {
        this.devicetypeRepository = devicetypeRepository;
        this.devicetypeMapper = devicetypeMapper;
    }


    @Override
    //@Cacheable(key = "#p0")
    public DevicetypeDto findById(Long id) {
        Devicetype devicetype = devicetypeRepository.findById(id).orElseGet(Devicetype::new);
        ValidationUtil.isNull(devicetype.getId(),"Devicetype","id",id);
        return devicetypeMapper.toDto(devicetype);
    }

}
